#!/usr/bin/env python
#Vmtr2a_Tk.py
import time
import RPi.GPIO as GPIO
import math
import Tkinter
from Tkinter import *

#GPIO-Pins
#ADC0831_2 
AD_Dat1  = 2 
# Bei Betrieb des A/D-Wandlers mit Vcc= +5V 
             # unbedingt eine Reihenschaltung zweier geeigneter Widerstaende 
             # zur Begrenzung der Ausgangsspannung auf ca. 3V vorsehen! 
             # Vergleichen Sie dazu bitte die Darstellungen im Schaltplan!   
AD_Clk1 = 4
AD_CS1 = 3   



out=GPIO.output
inp=GPIO.input
low=GPIO.LOW
hi=GPIO.HIGH

#GPIO-Festlegungen
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
#ADC0831_1
GPIO.setup(AD_CS1,GPIO.OUT)
GPIO.setup(AD_Dat1,GPIO.IN)
GPIO.setup(AD_Clk1,GPIO.OUT)



#ReL1, ReL2 zur Messbereichserweiterung
ReL1=24
GPIO.setup(ReL1,GPIO.OUT)


#Anfangszustaende
out(AD_CS1,hi)
out(ReL1,low)#Vorwiderstand ein


ADWert1=0


def AD_einlesen1():
    out(AD_Clk1,low)
    AD_byte1=0
    for n in range(8):  # ADW 8 mal einlesen
        time.sleep(0.001)        		
        #out(AD_CS1,hi)
        Bit7_1=0x80
        time.sleep(0.001)
        out(AD_CS1,low)
        time.sleep(0.001)
        Analogwert1=0
        out(AD_Clk1,hi)     # vgl. Darstellungen in den
        time.sleep(0.001)  #  Datenblaettern des ADC0831
        out(AD_Clk1,low)
        time.sleep(0.001)
        out(AD_Clk1,hi)
        time.sleep(0.001)
        out(AD_Clk1,low)
        time.sleep(0.001)
        for z in range(8):#  8 Bit an AD_Dat1 einlesen
            if (inp(AD_Dat1)):
                Analogwert1=Analogwert1|Bit7_1 
            out(AD_Clk1,hi)
            time.sleep(0.002)
            out(AD_Clk1,low)	 
            Bit7_1=Bit7_1>>1   # 1 Bit nach rechts schieben
            time.sleep(0.002)
            Ergebnis1=Analogwert1
        out(AD_CS1,hi)    
        AD_byte1=AD_byte1+Analogwert1
    AD_byte1=AD_byte1/8
    
    AD_Ergebnis1=AD_byte1    
    return AD_Ergebnis1	
   


                                  # "Eichen" der Spannungsmesseranzeige
                                  # mithilfe einer Vergleichsmessung
                                  # z. B. mit einem Digitalmultimeter
                                  # Wert 1960 in 5er- oder 10er-Schritten
                                  # verkleinern, z. B. wie hier auf 1910
def Umrechnungen1(ADWert1):       # wegen Spannung in V =AD_Ergebnis*5V/255
    Spg_wert1=ADWert1             # 5/255 = 0.019607843 
    Spg_wert1=Spg_wert1*1950 # war 1960,z. B. ADWert=127 --> Spg_wert=127*1960=248920  
    Spg_wert1=Spg_wert1/1000 # 248
    Darstellungswert1=Spg_wert1/2 # 124 fuer die Zeigerdarstellung 
    Ziffer_eins1=Spg_wert1/100    # 2
    rest_z1=Spg_wert1 % 100       # 48
    Ziffer_zwei1=rest_z1/10            # 4
    Ziffer_drei1=rest_z1%10            # 8
    return Ziffer_eins1, Ziffer_zwei1, Ziffer_drei1, Darstellungswert1,Spg_wert1
        	





def ende():
    main.destroy()



main =Tkinter.Tk()


counter1=0
picval1=0
 

def counter1_label(label1):
    
    def count1():
        global counter1
        counter1 +=1
        ADWert1 = AD_einlesen1()
        ADWert1_tmp=ADWert1
        
        #Umrechnungen1(ADWert1)
        Ziffer_eins1,Ziffer_zwei1,Ziffer_drei1,Darstellungswert1,Spg_wert1=Umrechnungen1(ADWert1)
        
        label1.config(text="U2: " + str(Ziffer_eins1)+"."+str(Ziffer_zwei1)+str(Ziffer_drei1)+" V")
        
        #stets zuerst weisse Flaeche darstellen, also urspruengliche Anzeige loeschen
        c_b.create_line(100,30,350,30, fill="white", width=30)
        
        #danach blauen Balken darstellen als quasianaloge Anzeige der 1. Spannung  
        c_b.create_line(100,30,100+Darstellungswert1,30, fill="red", width=28)
     
        label1.after(1000, count1)
    
             
    count1()



#frame0, das die anderen Frames enthaelt
frm0=Tkinter.Frame(main,width=220,height=50,relief="sunken")
frm0.pack(pady=5,side="top")

#frame fuer label1
frm1=Tkinter.Frame(frm0,width=220,height=50,relief="sunken")
frm1.pack(pady=5,side="top")

#Zeichenflaeche1 in frm1
c_b=Tkinter.Canvas(frm1)
c_b["width"]=410
c_b["height"]=80
c_b["borderwidth"]=3
c_b["relief"]= "ridge"
c_b.pack(side="top")

#Skala in frame1
for n in range(6):#lange Striche
    c_b.create_line(100+n*50,60,100+n*50,78,fill="black",width=1)
    
for n in range(11):#kurze Striche
    c_b.create_line(100+n*25,60,100+n*25,69,fill="black",width=1)
#Rechteck 
c_b.create_rectangle(99, 14, 351,45, width=1) 
 


#Label fuer die Spannungsanzeige 1    
label1=Tkinter.Label(frm1,text="U1: ",font="Arial 40 bold",height=1,width=14,borderwidth=5,relief="groove",bg="white",fg="red",anchor="center")
label1.pack(pady=2,side="top")
counter1_label(label1)

#frame2 fuer die "blauen" Radiobuttons 
frm2=Tkinter.Frame(frm0,width=220,height=50,relief="sunken")
frm2.pack(pady=5,side="top")

#Variablen
Messbereich1=Tkinter.StringVar()
Messbereich1.set("10V")
blau10_v=Tkinter.StringVar()



#Kommandofunktionen(Callbacks) fuer die Radiobuttons  blau_5V sowie blau_10V
def rot_5V():
    out(ReL1,hi)#kein Vorwiderstand
    label_rot5=Tkinter.Label(frm1,text=" x 1",font="Arial 25",bg="white",fg="red")
    label_rot5.place(x=395,y=125,anchor="e")    
def rot_10V():
    out(ReL1,low)#Vorwiderstand ein
    label_rot10=Tkinter.Label(frm1,text=" x 2",font="Arial 25",bg="white",fg="red")
    label_rot10.place(x=395,y=125,anchor="e")
    
rot_10V()
  
#Zwei "blaue" Radiobuttons zur blauen Spannungsanzeige
rad1_bt1=Tkinter.Radiobutton(frm2, text=" 5V ",font="Arial 20",indicatoron=0,variable="Messbereich1",value="5V",fg="red",command=rot_5V)
rad1_bt1.pack(padx=10,side="left")

rad1_bt2=Tkinter.Radiobutton(frm2, text="10V",font="Arial 20",indicatoron=0,variable="Messbereich1",value="10V",fg="red",command=rot_10V)
rad1_bt2.pack(padx=10,side="left")


#Ende-button 
button=Tkinter.Button(main,text="Ende",height=1,font ="Arial 15 bold",width=10,command = main.destroy)
button.pack(pady=2, side="bottom")        

mainloop()


